package com.lightinit.hsdataportal.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class ResourceMicroappExample extends BaseExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public ResourceMicroappExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andProviderIsNull() {
            addCriterion("provider is null");
            return (Criteria) this;
        }

        public Criteria andProviderIsNotNull() {
            addCriterion("provider is not null");
            return (Criteria) this;
        }

        public Criteria andProviderEqualTo(Long value) {
            addCriterion("provider =", value, "provider");
            return (Criteria) this;
        }

        public Criteria andProviderNotEqualTo(Long value) {
            addCriterion("provider <>", value, "provider");
            return (Criteria) this;
        }

        public Criteria andProviderGreaterThan(Long value) {
            addCriterion("provider >", value, "provider");
            return (Criteria) this;
        }

        public Criteria andProviderGreaterThanOrEqualTo(Long value) {
            addCriterion("provider >=", value, "provider");
            return (Criteria) this;
        }

        public Criteria andProviderLessThan(Long value) {
            addCriterion("provider <", value, "provider");
            return (Criteria) this;
        }

        public Criteria andProviderLessThanOrEqualTo(Long value) {
            addCriterion("provider <=", value, "provider");
            return (Criteria) this;
        }

        public Criteria andProviderIn(List<Long> values) {
            addCriterion("provider in", values, "provider");
            return (Criteria) this;
        }

        public Criteria andProviderNotIn(List<Long> values) {
            addCriterion("provider not in", values, "provider");
            return (Criteria) this;
        }

        public Criteria andProviderBetween(Long value1, Long value2) {
            addCriterion("provider between", value1, value2, "provider");
            return (Criteria) this;
        }

        public Criteria andProviderNotBetween(Long value1, Long value2) {
            addCriterion("provider not between", value1, value2, "provider");
            return (Criteria) this;
        }

        public Criteria andServiceMethodIsNull() {
            addCriterion("service_method is null");
            return (Criteria) this;
        }

        public Criteria andServiceMethodIsNotNull() {
            addCriterion("service_method is not null");
            return (Criteria) this;
        }

        public Criteria andServiceMethodEqualTo(String value) {
            addCriterion("service_method =", value, "serviceMethod");
            return (Criteria) this;
        }

        public Criteria andServiceMethodNotEqualTo(String value) {
            addCriterion("service_method <>", value, "serviceMethod");
            return (Criteria) this;
        }

        public Criteria andServiceMethodGreaterThan(String value) {
            addCriterion("service_method >", value, "serviceMethod");
            return (Criteria) this;
        }

        public Criteria andServiceMethodGreaterThanOrEqualTo(String value) {
            addCriterion("service_method >=", value, "serviceMethod");
            return (Criteria) this;
        }

        public Criteria andServiceMethodLessThan(String value) {
            addCriterion("service_method <", value, "serviceMethod");
            return (Criteria) this;
        }

        public Criteria andServiceMethodLessThanOrEqualTo(String value) {
            addCriterion("service_method <=", value, "serviceMethod");
            return (Criteria) this;
        }

        public Criteria andServiceMethodLike(String value) {
            addCriterion("service_method like", value, "serviceMethod");
            return (Criteria) this;
        }

        public Criteria andServiceMethodNotLike(String value) {
            addCriterion("service_method not like", value, "serviceMethod");
            return (Criteria) this;
        }

        public Criteria andServiceMethodIn(List<String> values) {
            addCriterion("service_method in", values, "serviceMethod");
            return (Criteria) this;
        }

        public Criteria andServiceMethodNotIn(List<String> values) {
            addCriterion("service_method not in", values, "serviceMethod");
            return (Criteria) this;
        }

        public Criteria andServiceMethodBetween(String value1, String value2) {
            addCriterion("service_method between", value1, value2, "serviceMethod");
            return (Criteria) this;
        }

        public Criteria andServiceMethodNotBetween(String value1, String value2) {
            addCriterion("service_method not between", value1, value2, "serviceMethod");
            return (Criteria) this;
        }

        public Criteria andServiceChannelIsNull() {
            addCriterion("service_channel is null");
            return (Criteria) this;
        }

        public Criteria andServiceChannelIsNotNull() {
            addCriterion("service_channel is not null");
            return (Criteria) this;
        }

        public Criteria andServiceChannelEqualTo(String value) {
            addCriterion("service_channel =", value, "serviceChannel");
            return (Criteria) this;
        }

        public Criteria andServiceChannelNotEqualTo(String value) {
            addCriterion("service_channel <>", value, "serviceChannel");
            return (Criteria) this;
        }

        public Criteria andServiceChannelGreaterThan(String value) {
            addCriterion("service_channel >", value, "serviceChannel");
            return (Criteria) this;
        }

        public Criteria andServiceChannelGreaterThanOrEqualTo(String value) {
            addCriterion("service_channel >=", value, "serviceChannel");
            return (Criteria) this;
        }

        public Criteria andServiceChannelLessThan(String value) {
            addCriterion("service_channel <", value, "serviceChannel");
            return (Criteria) this;
        }

        public Criteria andServiceChannelLessThanOrEqualTo(String value) {
            addCriterion("service_channel <=", value, "serviceChannel");
            return (Criteria) this;
        }

        public Criteria andServiceChannelLike(String value) {
            addCriterion("service_channel like", value, "serviceChannel");
            return (Criteria) this;
        }

        public Criteria andServiceChannelNotLike(String value) {
            addCriterion("service_channel not like", value, "serviceChannel");
            return (Criteria) this;
        }

        public Criteria andServiceChannelIn(List<String> values) {
            addCriterion("service_channel in", values, "serviceChannel");
            return (Criteria) this;
        }

        public Criteria andServiceChannelNotIn(List<String> values) {
            addCriterion("service_channel not in", values, "serviceChannel");
            return (Criteria) this;
        }

        public Criteria andServiceChannelBetween(String value1, String value2) {
            addCriterion("service_channel between", value1, value2, "serviceChannel");
            return (Criteria) this;
        }

        public Criteria andServiceChannelNotBetween(String value1, String value2) {
            addCriterion("service_channel not between", value1, value2, "serviceChannel");
            return (Criteria) this;
        }

        public Criteria andServiceTagIsNull() {
            addCriterion("service_tag is null");
            return (Criteria) this;
        }

        public Criteria andServiceTagIsNotNull() {
            addCriterion("service_tag is not null");
            return (Criteria) this;
        }

        public Criteria andServiceTagEqualTo(String value) {
            addCriterion("service_tag =", value, "serviceTag");
            return (Criteria) this;
        }

        public Criteria andServiceTagNotEqualTo(String value) {
            addCriterion("service_tag <>", value, "serviceTag");
            return (Criteria) this;
        }

        public Criteria andServiceTagGreaterThan(String value) {
            addCriterion("service_tag >", value, "serviceTag");
            return (Criteria) this;
        }

        public Criteria andServiceTagGreaterThanOrEqualTo(String value) {
            addCriterion("service_tag >=", value, "serviceTag");
            return (Criteria) this;
        }

        public Criteria andServiceTagLessThan(String value) {
            addCriterion("service_tag <", value, "serviceTag");
            return (Criteria) this;
        }

        public Criteria andServiceTagLessThanOrEqualTo(String value) {
            addCriterion("service_tag <=", value, "serviceTag");
            return (Criteria) this;
        }

        public Criteria andServiceTagLike(String value) {
            addCriterion("service_tag like", value, "serviceTag");
            return (Criteria) this;
        }

        public Criteria andServiceTagNotLike(String value) {
            addCriterion("service_tag not like", value, "serviceTag");
            return (Criteria) this;
        }

        public Criteria andServiceTagIn(List<String> values) {
            addCriterion("service_tag in", values, "serviceTag");
            return (Criteria) this;
        }

        public Criteria andServiceTagNotIn(List<String> values) {
            addCriterion("service_tag not in", values, "serviceTag");
            return (Criteria) this;
        }

        public Criteria andServiceTagBetween(String value1, String value2) {
            addCriterion("service_tag between", value1, value2, "serviceTag");
            return (Criteria) this;
        }

        public Criteria andServiceTagNotBetween(String value1, String value2) {
            addCriterion("service_tag not between", value1, value2, "serviceTag");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(Long value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(Long value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(Long value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(Long value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(Long value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(Long value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<Long> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<Long> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(Long value1, Long value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(Long value1, Long value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNull() {
            addCriterion("deleted_at is null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNotNull() {
            addCriterion("deleted_at is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtEqualTo(Date value) {
            addCriterion("deleted_at =", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotEqualTo(Date value) {
            addCriterion("deleted_at <>", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThan(Date value) {
            addCriterion("deleted_at >", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("deleted_at >=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThan(Date value) {
            addCriterion("deleted_at <", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThanOrEqualTo(Date value) {
            addCriterion("deleted_at <=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIn(List<Date> values) {
            addCriterion("deleted_at in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotIn(List<Date> values) {
            addCriterion("deleted_at not in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtBetween(Date value1, Date value2) {
            addCriterion("deleted_at between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotBetween(Date value1, Date value2) {
            addCriterion("deleted_at not between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNull() {
            addCriterion("deleted_by is null");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNotNull() {
            addCriterion("deleted_by is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedByEqualTo(Long value) {
            addCriterion("deleted_by =", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotEqualTo(Long value) {
            addCriterion("deleted_by <>", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThan(Long value) {
            addCriterion("deleted_by >", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThanOrEqualTo(Long value) {
            addCriterion("deleted_by >=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThan(Long value) {
            addCriterion("deleted_by <", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThanOrEqualTo(Long value) {
            addCriterion("deleted_by <=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByIn(List<Long> values) {
            addCriterion("deleted_by in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotIn(List<Long> values) {
            addCriterion("deleted_by not in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByBetween(Long value1, Long value2) {
            addCriterion("deleted_by between", value1, value2, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotBetween(Long value1, Long value2) {
            addCriterion("deleted_by not between", value1, value2, "deletedBy");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}